<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" size="small" v-show="showSearch" label-width="68px">
      <el-form-item label="活动时间" prop="activityTime">
        <el-date-picker clearable size="small" style="width: 200px"
          v-model="queryParams.activityTime"
          type="date"
          value-format="yyyy-MM-dd"
          placeholder="选择活动时间">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="活动地点" prop="activityVenue">
        <el-input
          v-model="queryParams.activityVenue"
          placeholder="请输入活动地点"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="备注" prop="remarks">
        <el-input
          v-model="queryParams.remarks"
          placeholder="请输入备注"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="归属部门" prop="deptId" style="width: 268px;">
        <treeselect style="width: 200px;" v-model="queryParams.deptId" :options="deptOptions" :show-count="true" placeholder="请选择归属部门" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['branch:activitynotice:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['branch:activitynotice:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['branch:activitynotice:remove']"
        >删除</el-button>
      </el-col>
      <!--<el-col :span="1.5">-->
        <!--<el-button-->
          <!--type="info"-->
          <!--plain-->
          <!--icon="el-icon-upload2"-->
          <!--size="mini"-->
          <!--@click="handleImport"-->
          <!--v-hasPermi="['branch:activitynotice:edit']"-->
        <!--&gt;导入</el-button>-->
      <!--</el-col>-->
      <!--<el-col :span="1.5">-->
        <!--<el-button-->
          <!--type="warning"-->
          <!--plain-->
          <!--icon="el-icon-download"-->
          <!--size="mini"-->
          <!--@click="handleExport"-->
          <!--v-hasPermi="['branch:activitynotice:export']"-->
        <!--&gt;导出</el-button>-->
      <!--</el-col>-->
	  <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="activitynoticeList" @selection-change="handleSelectionChange" :height="clientHeight" border>
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="党支部" align="center" prop="deptId" width="120" :formatter="deptListFormat"/>
      <el-table-column label="联系点领导" align="center" prop="contactLeaderString" width="120" />
      <el-table-column label="活动时间" align="center" prop="activityTime" width="100">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.activityTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="活动地点" align="center" prop="activityVenue" width="120" />
      <el-table-column label="活动内容" align="center" prop="activityContent" width="350" />
      <el-table-column label="联系点领导参加情况" align="center" prop="leaderAttendance" width="120" />
      <el-table-column label="备注" align="center" prop="remarks" width="120" />
      <el-table-column label="操作" align="center" fixed="right" width="120" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['branch:activitynotice:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['branch:activitynotice:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改支部活动预告对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="85px">
        <el-row>
          <el-col :span="12">
            <el-form-item label="党支部" prop="deptId" style="width: 300px;">
              <treeselect v-model="form.deptId" :options="deptOptions" :show-count="true" placeholder="请选择党支部" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="联系点领导" prop="contactLeader">
              <el-select v-model="form.contactLeader" multiple placeholder="请选择联系点领导">
                <el-option
                  v-for="dict in userList"
                  :key="dict.dictValue"
                  :label="dict.dictLabel"
                  :value="dict.dictValue"
                ></el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item label="活动时间" prop="activityTime">
              <el-date-picker clearable size="small" style="width: 200px"
                              v-model="form.activityTime"
                              type="date"
                              value-format="yyyy-MM-dd"
                              placeholder="选择活动时间">
              </el-date-picker>
            </el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item label="活动地点" prop="activityVenue">
              <el-input v-model="form.activityVenue" placeholder="请输入活动地点" />
            </el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item label="活动内容" prop="activityContent">
              <el-input v-model="form.activityContent" placeholder="请输入活动内容" type="textarea" :rows="4" />
            </el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item label="联系点领导参加情况" prop="leaderAttendance">
              <el-input v-model="form.leaderAttendance" placeholder="请输入联系点领导参加情况" />
            </el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item label="活动经费">
              <el-table :data="activitybudgetList" border>
                <el-table-column label="分项" align="center" prop="budgetItem">
                  <template slot-scope="scope">
                    <el-input v-model="scope.row.budgetItem" />
                  </template>
                </el-table-column>
                <el-table-column label="预算金额" align="center" prop="budgetAmount">
                  <template slot-scope="scope">
                    <el-input v-model="scope.row.budgetAmount" @input="calcBudget"/>
                  </template>
                </el-table-column>
                <el-table-column label="操作" align="center" fixed="right" width="120" class-name="small-padding fixed-width">
                  <template slot-scope="scope">
                    <el-button
                      size="mini"
                      type="text"
                      icon="el-icon-delete"
                      @click="handleDeleteBudget(scope.row)"
                    >删除分项</el-button>
                  </template>
                </el-table-column>
              </el-table>
              <el-button
                type="primary"
                plain
                icon="el-icon-plus"
                size="mini"
                @click="handleAddBudget"
              >添加分项</el-button>
            </el-form-item>
            </el-col>
          <el-col :span="24">
            <el-form-item label="预算总额" >
              <span v-if="form.budget != null" v-text="form.budget"></span>
            </el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item label="备注" prop="remarks">
              <el-input v-model="form.remarks" placeholder="请输入备注" />
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <!-- 用户导入对话框 -->
    <el-dialog :title="upload.title" :visible.sync="upload.open" width="400px" append-to-body>
        <el-upload
                ref="upload"
                :limit="1"
                accept=".xlsx, .xls"
                :headers="upload.headers"
                :action="upload.url + '?updateSupport=' + upload.updateSupport"
                :disabled="upload.isUploading"
                :on-progress="handleFileUploadProgress"
                :on-success="handleFileSuccess"
                :auto-upload="false"
                drag
        >
            <i class="el-icon-upload"></i>
            <div class="el-upload__text">
                将文件拖到此处，或
                <em>点击上传</em>
            </div>
            <div class="el-upload__tip" slot="tip">
                <el-checkbox v-model="upload.updateSupport" />是否更新已经存在的用户数据
                <el-link type="info" style="font-size:12px" @click="importTemplate">下载模板</el-link>
            </div>
            <div class="el-upload__tip" style="color:red" slot="tip">提示：仅允许导入“xls”或“xlsx”格式文件！</div>
        </el-upload>
        <div slot="footer" class="dialog-footer">
            <el-button type="primary" @click="submitFileForm">确 定</el-button>
            <el-button @click="upload.open = false">取 消</el-button>
        </div>
    </el-dialog>
  </div>
</template>

<script>
import { listActivitybudget, getActivitybudget, delActivitybudget, addActivitybudget, updateActivitybudget, exportActivitybudget} from "@/api/branch/activitybudget";
import { listActivitynotice, getActivitynotice, delActivitynotice, addActivitynotice, updateActivitynotice, exportActivitynotice} from "@/api/branch/activitynotice";
import { treeselect } from "@/api/system/dept";
import { getToken } from "@/utils/auth";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import { listUserNoPage } from "@/api/system/user";
import { listDept } from "@/api/system/dept";

export default {
  name: "Activitynotice",
  components: { Treeselect },
  // components: { Editor },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: false,
      // 总条数
      total: 0,
      // 支部活动预告表格数据
      activitynoticeList: [],
      // 支部活动预算表格数据
      activitybudgetList: [],
      // 弹出层标题
      title: "",
      // 部门树选项
      deptOptions: undefined,
      clientHeight:300,
      // 是否显示弹出层
      open: false,
        // 用户导入参数
        upload: {
            // 是否显示弹出层（用户导入）
            open: false,
            // 弹出层标题（用户导入）
            title: "",
            // 是否禁用上传
            isUploading: false,
            // 是否更新已经存在的用户数据
            updateSupport: 0,
            // 设置上传的请求头部
            headers: { Authorization: "Bearer " + getToken() },
            // 上传的地址
            url: process.env.VUE_APP_BASE_API + "/branch/activitynotice/importData"
        },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        noticeId: null,
        contactLeader: null,
        activityTime: null,
        activityVenue: null,
        activityContent: null,
        leaderAttendance: null,
        remarks: null,
        deptId: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        deptId: [
          { required: true, message: "党支部不能为空", trigger: "blur" }
        ],
        activityTime: [
          { required: true, message: "时间不能为空", trigger: "blur" }
        ],
        activityVenue: [
          { required: true, message: "地点不能为空", trigger: "blur" }
        ],
      },
      // 用户列表
      userList: [],
    };
  },
  watch: {
        // 根据名称筛选部门树
        deptName(val) {
            this.$refs.tree.filter(val);
        }
   },
  created() {
      //设置表格高度对应屏幕高度
      this.$nextTick(() => {
          this.clientHeight = document.body.clientHeight -250
      })
    this.getDeptList();
    this.getList();
    this.getTreeselect();
  },
  methods: {
    calcBudget() {
      let sum = 0;
      for (let i = 0; i< this.activitybudgetList.length; i++) {
        this.activitybudgetList[i].index = i;
        if (!isNaN(this.activitybudgetList[i].budgetAmount)) {
          sum += Number(this.activitybudgetList[i].budgetAmount);
        }
      }
      this.form.budget = sum;
      this.$forceUpdate();
    },
    handleDeleteBudget(row) {
      let newList = [];
      for (let i = 0; i < this.activitybudgetList.length; i++) {
        if (row.index != this.activitybudgetList[i].index) {
          newList.push(this.activitybudgetList[i]);
        }
      }
      this.activitybudgetList = newList;
      this.calcBudget();
    },
    handleAddBudget() {
      if (this.activitybudgetList.length == 0) {
        this.activitybudgetList.push({ "index": 0,"budgetItem": null, "budgetAmount": null });
      } else {
        this.activitybudgetList.push({ "index": this.activitybudgetList[this.activitybudgetList.length-1].index+1,"budgetItem": null, "budgetAmount": null });
      }
    },
    /** 查询部门列表 */
    getDeptList() {
      listDept().then(response => {
        let data = response.data;
        let deptList = [];
        for(let i = 0; i < data.length; i++) {
          let dept = { "dictValue" : data[i].deptId, "dictLabel" : data[i].deptName};
          deptList.push(dept);
        }
        this.deptList = deptList;
      });
    },
    // 部门列表字典翻译
    deptListFormat(row, column) {
      return this.selectDictLabel(this.deptList, row.deptId);
    },
    /** 查询支部活动预告列表 */
    getList() {
      this.loading = true;
      listUserNoPage().then(response => {
        let rows = response.data;
        let userList = [];
        for(let i = 0; i < rows.length; i++) {
          if (rows[i].userName != "admin") {
            let user = { "dictValue" : rows[i].userId, "dictLabel" : rows[i].nickName};
            userList.push(user);
          }
        }
        this.userList = userList;
        listActivitynotice(this.queryParams).then(response => {
          this.activitynoticeList = response.rows;
          for (let i = 0; i < this.activitynoticeList.length; i++) {
            if (this.activitynoticeList[i].contactLeader != null) {
              let contactLeader = this.activitynoticeList[i].contactLeader.split(",");
              let contactLeaderString = "";
              for (let j = 0; j < contactLeader.length; j++) {
                if (j > 0) {
                  contactLeaderString += "、" + this.selectDictLabel(this.userList, contactLeader[j]);
                } else {
                  contactLeaderString += this.selectDictLabel(this.userList, contactLeader[j]);
                }
              }
              this.activitynoticeList[i].contactLeaderString = contactLeaderString;
            }
          }
          this.total = response.total;
          this.loading = false;
        });
      });
    },
     /** 查询部门下拉树结构 */
     getTreeselect() {
          treeselect().then(response => {
              this.deptOptions = response.data;
          });
     },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        noticeId: null,
        contactLeader: null,
        activityTime: null,
        activityVenue: null,
        activityContent: null,
        leaderAttendance: null,
        remarks: null,
        delFlag: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        deptId: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.noticeId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加支部活动预告";
      this.activitybudgetList = [];
      this.activitybudgetList.push({ "index": 0,"budgetItem": null, "budgetAmount": null });
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.activitybudgetList = [];
      this.reset();
      const noticeId = row.noticeId || this.ids
      getActivitynotice(noticeId).then(response => {
        this.form = response.data;
        this.activitybudgetList = response.data.budgetList;
        this.calcBudget();
        if (this.form.contactLeader != null) {
          this.form.contactLeader = this.form.contactLeader.split(",").map(Number);
        }
        this.open = true;
        this.title = "修改支部活动预告";
      });
    },
      /** 提交按钮 */
      submitForm() {
        if (this.form.contactLeader != null) {
          this.form.contactLeader = this.form.contactLeader.join();
        }
        this.form.budgetList = this.activitybudgetList;
          this.$refs["form"].validate(valid => {
              if (valid) {
                  if (this.form.noticeId != null) {
                      updateActivitynotice(this.form).then(response => {
                          this.$modal.msgSuccess("修改成功");
                          this.open = false;
                          this.getList();
                      });
                  } else {
                      addActivitynotice(this.form).then(response => {
                          this.$modal.msgSuccess("新增成功");
                          this.open = false;
                          this.getList();
                      });
                  }
              }
          });
      },
    /** 删除按钮操作 */
    handleDelete(row) {
      const noticeIds = row.noticeId || this.ids;
      this.$confirm('是否确认删除?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delActivitynotice(noticeIds);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有支部活动预告数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportActivitynotice(queryParams);
        }).then(response => {
          this.download(response.msg);
        })
    },
      /** 导入按钮操作 */
      handleImport() {
          this.upload.title = "用户导入";
          this.upload.open = true;
      },
      /** 下载模板操作 */
      importTemplate() {
          importTemplate().then(response => {
              this.download(response.msg);
          });
      },
      // 文件上传中处理
      handleFileUploadProgress(event, file, fileList) {
          this.upload.isUploading = true;
      },
      // 文件上传成功处理
      handleFileSuccess(response, file, fileList) {
          this.upload.open = false;
          this.upload.isUploading = false;
          this.$refs.upload.clearFiles();
          this.$alert(response.msg, "导入结果", { dangerouslyUseHTMLString: true });
          this.getList();
      },
      // 提交上传文件
      submitFileForm() {
          this.$refs.upload.submit();
      }
  }
};
</script>

<style>
    /** 文本换行符处理 */
    .el-table .cell{
        white-space: pre-wrap;
    }
    /** textarea字体 */
    textarea {
        font-family: "Helvetica Neue",Helvetica,"PingFang SC","Hiragino Sans GB","Microsoft YaHei","微软雅黑",Arial,sans-serif;
    }
</style>
